/*
    Copyright 2010 Marco A. Montes de Oca, Dogan Aydin and Thomas Stuetzle

    This file is part of IPSOLS.

    IPSOLS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    IPSOLS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with IPSOLS.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef IPSO_H
#define IPSO_H

#include "configuration.h"
#include "swarm.h"
#include "problem.h"
#include "pso.h"
#include "localSearch.h"

class IncrementalPSO: public PSO{

      private:
	double iwMin, iwMax, coefMin, coefMax, velMin, velMax;
	LocalSearch* ls;
	
      public:

	 IncrementalPSO(Configuration* config, Swarm* swarm, Problem* problem);
        ~IncrementalPSO();

        bool notDone();
        void run();

        void applyLocalSearch(LocalSearch* ls, Particle * p);

};

#endif

