#ifndef POWELL_H
#define POWELL_H
/* $Id: powell.h,v 1.2 2006/02/19 23:59:12 hvengel Exp $ */
/* Powell multivariate minimiser */

/*
 * Copyright 2000 Graeme W. Gill
 * All rights reserved.
 *
 * This material is licenced under the GNU GENERAL PUBLIC LICENCE :-
 * see the Licence.txt file for licencing details.
 */

#include "numsup.h"
#include "localSearchProblems.h"

#define FTOL_REACHED -2
#define MAXEVAL_REACHED 1

/* Standard interface for powell function */
/* return err on sucess, -1.0 on failure */
/* Result will be in cp */
/* Arrays start at 0 */
int powell(
int di,					/* Dimentionality */
double cp[],			/* Initial starting point */
double s,				/* Size of initial search area */
double ftol,			/* Tollerance of error change to stop on */
int maxit,				/* Maximum iterations allowed */
obj_func fun, 		/* Error function to evaluate */
long double * fun_data,         /* additional information if required, if not pass NULL*/
long double *minf);		    /* out: minimum value of the function */

#endif /* POWELL_H */
