/*
    Copyright 2010 Marco A. Montes de Oca, Dogan Aydin and Thomas Stuetzle

    This file is part of IPSOLS.

    IPSOLS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    IPSOLS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with IPSOLS.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PSO_H
#define PSO_H

#include "configuration.h"
#include "swarm.h"
#include "problem.h"

class PSO {
	    
      protected:
	Configuration* config;	
	Swarm* s;
	Problem* p;	
	
      public:
	PSO(Configuration* config, Swarm* swarm, Problem* problem);
 	virtual ~PSO();

	virtual bool notDone() = 0;		

	double limitVelocity(double vel);
	double clampPosition(double candidate);	
	double clampPositionVelocity(double candidate,double* velocity);	
	double reboundPosition(double candidate,double* velocity);

	virtual void run() = 0;		
			
	void printSolution();
		
};

#endif

