/*
    Copyright 2010 Marco A. Montes de Oca, Dogan Aydin and Thomas Stuetzle

    This file is part of IPSOLS.

    IPSOLS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    IPSOLS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with IPSOLS.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef RNG_H
#define RNG_H

#include <gsl/gsl_rng.h>
#include <gsl/gsl_permutation.h>

class RNG{
public:
static gsl_rng* R;
static gsl_permutation* P;
static void initializeRNG( unsigned long int rngSeed );
static void initializePermutation(unsigned int size);

static double randVal(double min,double max);
static double randGauss(double sd);
static void shufflePermutation();
static int getPermutationElement(int index);

static void deallocateRNG();
static void deallocatePermutation();
};

#endif
